\ This software is free for use and modification by anyone for any purpose
\ with no restrictions or source identification of any kind.

\ Nov 6 2016 Douglas B. Hoffman
\ dhoffman888@gmail.com

DECIMAL

: ?? ( n n -- ) <> abort" ?? error!" ;

[defined] floats [if]
: f<> ( R: r r -- flag ) f- f0= 0= ;
: f?? ( R: r r -- ) f<> abort" f?? error!" ;
[then]


cr .( Test Basic Objects and Messaging )

var x
33 x !:
x @: 33 ??

3 x +:     
x @: 36 ??

cr .( testing class_as> ) 

: test 33 x class_as> var !: x class_as> var @: ;
test 33 ??

55 x class_as> var !: x class_as> var @:  55 ??



cr .( testing interpret late bind ) 

x value y
33 y !:
y @: 33 ??

3 y +:     
y @: 36 ??

cr .( testing compile late bind ) 

: test 33 y !: y @: ;
test 33 ??

cr .( Verify mixing message sends to public objects and ivars in a method )
var x1 66 x1 !:
var x2 77 x2 !:


:class var2 <super var
  :m get: self @: x1 @: self @: x2 @: ;m
;class

var2 v2 88 v2 !: 


v2 get: 77 ?? 88 ?? 66 ?? 88 ??
 

bool b 

b set:

b @: -1 ??
b clear:
b @: 0 ??


cr .( testing 1-array ) 

1-array a
5 a new:

a size: 5 ??
77 3 a to:
3 a at: 77 ??

: test 3 a at: ;
test 77 ??

0 a fill:
test 0 ??

cr .( testing each: and heap> ) 

45 2 a to:

: test begin a each: while  repeat ;

test 0 ?? 0 ?? 45 ?? 0 ?? 0 ??

: v heap> var ;

v 0 a to:
v 1 a to:
v 2 a to:
v 3 a to:
v 4 a to:


: test2 begin a each: while @: repeat ;

test2 0 ?? 0 ?? 0 ?? 0 ?? 0 ??

: add2 ( var-obj -- )
  2 swap +: ;

: test3 begin a each: while add2 repeat ; 

test3 test2 2 ?? 2 ?? 2 ?? 2 ?? 2 ??
test3 test2 4 ?? 4 ?? 4 ?? 4 ?? 4 ??

: test4 begin a each: while <free repeat ; test4

a free: 


cr .( testing 1-array sort )

: make-1-array heap> 1-array ; make-1-array value a
5 3 33 22 333 5 a set:
 
0 [if]
\ optional to using set:
0 a new:
5 a add:
3 a add:
33 a add:
22 a add:
333 a add:
[then]


a sort:
0 a at: 3 ??
1 a at: 5 ??
2 a at: 22 ??
3 a at: 33 ??
4 a at: 333 ??

78 66 1 99 4 a set:
a sort:
0 a at: 1 ??
1 a at: 66 ??
2 a at: 78 ??
3 a at: 99 ??

a <free
 

[defined] floats [if]
cr .( testing fp-array sort )


: make-fp-array heap> fp-array ; make-fp-array to a
5e 3e 33e 22e 333e 5 a set:
a sort:
0 a at: 3e f??
1 a at: 5e f??
2 a at: 22e f??
3 a at: 33e f??
4 a at: 333e f??
a <free

[then]


cr .( testing string+ )

true to case-sensitive?
string+ s

s" Now is" s !:  s"  the time" s add:


s @:  s" Now is the time" COMPARE 0 ??
s free:


string+ s2
s" Now is the time for all" s2 !:
s"  all" s2 search: -1 ??

s2 delete:  
s"  all" s2 search: 0 ??
s2 reset:  
s"  time" s2 search: -1 ??
s2 delete:  
s2 @:  s" Now is the for" COMPARE 0 ??
s2 free:

s" Now is the time" s !:


s selectall: s @sub:  s" Now is the time" COMPARE 0 ??
s @sub: s" Now is the time" COMPARE 0 ??
s @sub: s" Now is THE time" COMPARE 1 ??
false TO case-sensitive?

s" Now is THE time" s selectAll: s =sub: TRUE ??


true TO case-sensitive?
s" Now is THE time" s selectAll: s =sub: FALSE ??

s reset:
s" THE" s search: FALSE ??

s reset:
false TO case-sensitive?
s" THE" s search: TRUE ??

s free:
 

region-reset \ <<<NOTE!!!


cr .( testing string+ replall: )

true to case-sensitive?
string+ dot$
s" now.is.the.time.for.all.good.men.to.come.to.the.aid.of.their.country" dot$ !:
s" now.is.the.time.for.all.good.men.to.come.to.the.aid.of.their.country" dot$ add:
s" now.is.the.time.for.all.good.men.to.come.to.the.aid.of.their.country" dot$ add:
s" now.is.the.time.for.all.good.men.to.come.to.the.aid.of.their.country" dot$ add:
s" now.is.the.time.for.all.good.men.to.come.to.the.aid.of.their.country" dot$ add:
s" now.is.the.time.for.all.good.men.to.come.to.the.aid.of.their.country" dot$ add:
s" now.is.the.time.for.all.good.men.to.come.to.the.aid.of.their.country" dot$ add:
s" now.is.the.time.for.all.good.men.to.come.to.the.aid.of.their.country" dot$ add:
s" now.is.the.time.for.all.good.men.to.come.to.the.aid.of.their.country" dot$ add:
s" now.is.the.time.for.all.good.men.to.come.to.the.aid.of.their.country" dot$ add:
s" now.is.the.time.for.all.good.men.to.come.to.the.aid.of.their.country" dot$ add: 
s" now.is.the.time.for.all.good.men.to.come.to.the.aid.of.their.country" dot$ add:
s" now.is.the.time.for.all.good.men.to.come.to.the.aid.of.their.country" dot$ add:
s" now.is.the.time.for.all.good.men.to.come.to.the.aid.of.their.country" dot$ add:
s" now.is.the.time.for.all.good.men.to.come.to.the.aid.of.their.country" dot$ add:
s" now.is.the.time.for.all.good.men.to.come.to.the.aid.of.their.country" dot$ add:
s" now.is.the.time.for.all.good.men.to.come.to.the.aid.of.their.country" dot$ add:
s" now.is.the.time.for.all.good.men.to.come.to.the.aid.of.their.country" dot$ add:
s" now.is.the.time.for.all.good.men.to.come.to.the.aid.of.their.country" dot$ add:
s" now.is.the.time.for.all.good.men.to.come.to.the.aid.of.their.country" dot$ add:
s" now.is.the.time.for.all.good.men.to.come.to.the.aid.of.their.country" dot$ add:

create s1 ," ."
create s2 ,"  IV "

: test s1 count s2 count dot$ replall: ;

test  

dot$ size: 2373 ??
dot$ rem: 2373 ??
dot$ start: @ 0 ??
dot$ end: @ 0 ??

dot$ free:

region-reset  \ <<<NOTE!!! 
 

:class point  
  ivar x
  ivar y
  :m show: ( -- x y ) x @  y @  ;m
  :m dot: ( -- x y ) self show: ;m \ must late bind to self for demo
  :m init: 0 x !  0 y ! ;m
;class

:class rectangle    
  point ul
  point lr
  :m init: ul init: lr init: ;m
  :m show: ( -- x1 y1 x2 y2 ) ul dot:  lr dot: ;m
  :m dot: ( -- x1 y1 x2 y2 )  self show: ;m
;class


rectangle r


cr .( Message-less access of an instance variable in an instance variable )

cr 888 .. r.lr.y !
r dot: 888 ?? 0 ?? 0 ?? 0 ??



: make-rectangle heap> rectangle ; make-rectangle value rh
rh dot: 0 ?? 0 ?? 0 ?? 0 ??
rh <free
 

point origin

cr .( testing message-less instance variable access interpreted )

5 .. origin.x !  8 .. origin.y !
cr
origin show: 8 ?? 5 ??

cr .( testing message-less instance variable access compiled )

: test1 44 .. origin.x !  55 .. origin.y ! ;
test1
 
origin show: 55 ?? 44 ??


:class label-point <super point
  :m show: ( -- x+1 y+1 ) x @ 1+  y @ 1+ ;m
;class


label-point poo

poo dot: 1 ?? 1 ??


1-array icosohedron
20 icosohedron new:
: load-ico
  20 0 do dict> point i icosohedron to: loop ;
load-ico

: icosohedron[] ( index -- point-object )
  icosohedron at: ;

0 icosohedron[] dot: 0 ?? 0 ??

10 icosohedron[] dot: 0 ?? 0 ??

19 icosohedron[] dot: 0 ?? 0 ??

 
22  19 icosohedron[] .. .x !  777 19 icosohedron[] .. .y !

19 icosohedron[] dot: 777 ?? 22 ??

icosohedron free: 


: tester ( -- x y )
  heap> point  
  dup dot: rot 
  <free ;

tester 0 ?? 0 ??


cr .( testing indexed class ordered-col )

10 ordered-col c

0 c add:
10 c add:
20 c add:
30 c add:

c each: -1 ?? 0 ??
c each: -1 ?? 10 ??
c each: -1 ?? 20 ??
c each: -1 ?? 30 ??
c each: 0 ??

c each: -1 ?? 0 ??
c each: -1 ?? 10 ??
c each: -1 ?? 20 ??
c each: -1 ?? 30 ??

[defined] floats [if]
cr .( testing indexed class fordered-col )

6 fordered-col f 

6e f add:
88e f add:
f each:  -1 ?? 6e f??
f each: -1 ?? 88e f??
f each: 0 ??

f each:  -1 ?? 6e f??
f each: -1 ?? 88e f??
f each: 0 ??

[then]


[defined] begin-structure [if]
cr .( testing structures in classes )



 begin-structure point'
   1 cells +field p.x 
   1 cells +field p.y
 end-structure
 
 begin-structure rectangle' 
   point' +field r.ul
   point' +field r.lr 
 end-structure


 
:class rectangle-struct  
   rectangle' bytes rect
   :m addr: ( -- addr ) rect ;m
   :m init: 0 rect r.ul p.x !
            0 rect r.ul p.y !
            0 rect r.lr p.x !
            0 rect r.lr p.y ! ;m
   :m show: ( -- x1 y1 x2 y2 )
      rect r.ul p.x @
      rect r.ul p.y @
      rect r.lr p.x @
      rect r.lr p.y @ ;m
;class 

 
rectangle-struct t1

cr t1 addr: r.ul p.x . \ 1236932 ok
cr t1 addr: r.ul p.y . \ 1236936 ok
cr t1 addr: r.lr p.x . \ 1236940 ok
cr t1 addr: r.lr p.y . \ 1236944 ok
cr here . \ 1236948 ok
cr
cr .. t1.rect r.ul p.x . \ 1236932 ok
cr .. t1.rect r.ul p.y . \ 1236936 ok
cr .. t1.rect r.lr p.x . \ 1236940 ok
cr .. t1.rect r.lr p.y . \ 1236944 ok
cr here . \ 1236948 ok 

888 .. t1.rect r.lr p.y !
t1 show: 888 ?? 0 ?? 0 ?? 0 ??
[then]

cr .( testing indexed object as instance variable )

:class indexed-test   
  ivar x
  5 ordered-col c
  ivar y
  :m init: 7 x !  99 y ! c init:
      5 0 do i c add: loop ;m
  :m d: ( -- x c0 c1 c2 c3 c4 c5 y )
     x @ 5 0 do i c at: loop y @ ;m
;class

indexed-test t
cr 
t d: 99 ?? 4 ?? 3 ?? 2 ?? 1 ?? 0 ?? 7 ??


cr .( testing exit in a method )

:class var3 <super var
 :m exit: ( n1 -- 10 100 )
     begin
      1+ dup
      10 = if 100 exit then
     again ;m
;class

var3 v3
2 v3 exit: 100 ?? 10 ??

cr .( testing long string input )
\ checking used in VFX and MFonVFX
\ must be turned off for multi-whiles
[defined] checking [if] checking off [then]

: <text>  ( obj -- caddr u )
   >r
   begin
      refill
   while
      10 word count 2dup s" </text>" compare
   while
      r@ add: bl r@ +:
   repeat then 2drop r> drop
;

[defined] checking [if] checking on [then]

string+ ss3

ss3 <text>
Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod
tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim
veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea
commodo consequat. Duis aute irure dolor in reprehenderit in voluptate
velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint
occaecat cupidatat non proident, sunt in culpa qui officia deserunt
mollit anim id est laborum.
</text>

ss3 size: 446 ??

ss3 free:


[defined] floats [if]
cr .( testing integer list i{ ... } )

i{ 0 9 1 8
7 6 5 4 3 2 } value b
 

5 b at: 6 ??

9 b at: 2 ??
b size: 10 ??

b <free


cr .( testing string list ${ ... } )

${ now is the time
   for all the good men } to b

b sort: b p:

\ ${ all for good is men now the the time } 

2 b at: @: s" good" compare 0 ??
-1 b at: @: s" time" compare 0 ??
b size: 9 ??

b <free


cr .( testing fp list f{ ... } )

f{ 23 89e 3.4 677777e20 1 } to b

0 b at: 23e f??

4 b at: 1e f??
b sort:

2 b at: 23e f??

b <free


cr .( testing object lists o{ ... } )

0 value f 

o{ 'dog' 'cat' } to f  



0 f at@: s" dog" compare 0 ??

1 f at@: s" cat" compare 0 ??

f <free

 

o{ 1 'frog' 3.5e } to f

0 f at@: 1 ??
1 f at@: s" frog" compare 0 ??
2 f at@: 3.5e f??

f <free

o{ 'dog' { 1 { 3 4 5 } 2 } 'g' { 3e 4e 'cat' } } to f  



2 f at@: s" g" compare 0 ??

3 f at: dup 0 swap at@: 3e f??
2 swap at@: s" cat" compare 0 ??

f <free 



o{ 'dog' { 1 { 3 .. 10 { 'frog' 333e } 5 } 2 } 'g' { 3e 4e 'cat' } } to f   


1 f at: 1 swap at: 4 swap at@: 7 ??



f <free



[then]


 
cr .( Testing Hash-Table)

1 hash-table t 
\ 1 t init 

8888 s" Now is the time." t insert:
45 s" witch" t insert:
88 s" goofy frog" t insert: 
99 s" dog" t insert: 
100 s" mama" t insert: 
101 s" boy-boy" t insert: 
509 s" 2nd amendment" t insert:
7 s" foo bar" t insert: 
601 s" Presidential" t insert:

t d:   

s" mama" t delete: .
s" goofy frog" t delete: .
t d:
t free:



cr .( Testing Binary Tree - With Recursion )

: display-char ." (" 0 .R ." ) " ; 


btree b 

' emit b iv key-display-xt ! 

' display-char b iv info-displ-xt ! 


cr .( insert t d e r a )
char t dup b insert: 
char d dup b insert:
char e dup b insert:
char r dup b insert:
char a dup b insert:

cr .( b p: )  b p: 
cr char e b delete: . b p:
cr b sort:
b free:

region-reset  \ <<<NOTE!!! 

[defined] region-dispose [if] region-dispose [then]

cr cr .( FMS-SI Tests Concluded Successfully)


